# frozen_string_literal: true

require_relative "lib/ripcord/version"

Gem::Specification.new do |spec|
  spec.name = "ripcord"
  spec.version = Ripcord::VERSION
  spec.authors       = ["Klaus Zanders", "Pavel Forkert"]
  spec.email         = ["coding@kgz.me", "fxposter@gmail.com"]

  spec.summary       = "This is a JSON-RPC 2.0 client implementation with some specific additions (custom auth schemes, etc)"
  spec.description   = "JSON-RPC 2.0 client implementation"
  spec.homepage      = "https://github.com/klaustopher/ripcord"
  spec.license       = "MIT"

  spec.required_ruby_version = ">= 2.0.0"

  spec.metadata["homepage_uri"] = spec.homepage
  spec.metadata["source_code_uri"] = spec.homepage
  spec.metadata["changelog_uri"] = "https://github.com/klaustopher/ripcord/blob/master/CHANGELOG.md"

  # Specify which files should be added to the gem when it is released.
  # The `git ls-files -z` loads the files in the RubyGem that have been added into git.
  spec.files = Dir.chdir(File.expand_path(__dir__)) do
    `git ls-files -z`.split("\x0").reject do |f|
      (f == __FILE__) || f.match(%r{\A(?:(?:bin|test|spec|features)/|\.(?:git|travis|circleci)|appveyor)})
    end
  end

  spec.require_paths = ["lib"]
end
